////////////////////////////////////////////////////////////////////
//Julia-Iteration Single-Thread
//c-Werte aus Mandelbrot-Menge entnehmen
//Die Übersetzung in JavaSkript klappt nicht mit komplexer Klasse
//Daher double[2]
/////////////////////////////////////////////////////////////////////
double xU; 
double yU ; 
double wh ;
double xO = xU+wh;
double yO = yU+wh;
double xUStart ; 
double yUStart ; 
double xOStart ;
double yOStart;
double whStart = wh;
int[][] Treffer;
double[] zNeu,zAlt,zA,zB,z0,z1,z,zN,C,zW;
double zoomFaktor=1;
double Periode = 37.0;//alle indiffer. Fixpunkte, die an "Knospen" anliegen mit Attraktoren dieser Periode
double alpha ; //Winkel
double x,y; //Koordinaten indiff.FP
double[] koordinaten;//2-Dim
int maxiterations ;
int vorlauf =20;
int anzahlOrbitPunkte;
int orbitZeichnenAb = 1000;
int punktGroesse;
int aPI,bPI;
double massFuerUnendlich = 3;
double x0,y0;
double dx,dy;
double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
float a,b;
float aP,bP;
color farbe;
float farbWert;
double laenge,L,r,l0,l1;
boolean trajektZeichnen ;
boolean gJMZeichnen ;
boolean mMZeichnen;
boolean FPzeichnen ;
boolean mMSchreiben ;
boolean julia ;//gibt an, ob ein Julia- oder ein Mandelbrotbild gezeichnet ist
boolean cWerteEintragen; //spezielle c-Werte in Mandelbrot-Menge markierenboolean farbig = false;
boolean gruenC,rotC;
boolean jMZeichnen ;
boolean orbit ;//Drei Klick-Modi
boolean vergroessern ;//
boolean inJulia;//
boolean jMIIMZeichnen ;
int tastenH = 50;
int anzahlT;
int m; //zählt Orbitpunkte
int zaehlen ;
int anzahlStartgebiete;
int anzahlPunkteJM ;
boolean[] tasteAktiv;
boolean tastenWechsel=true;
boolean farbig=false;
char[] tBeschriftung;
PFont font;

////////////////////////////////////////////////////////////////////////
void setup() {
  size(800, 850);
  //additive Konstanten C
  background(255);
  x0= 0.2642858028411865; y0 =0.47142863273620605; //Konstante für Julia-Iteration
  xU = -1.8; 
  yU = -1.8; 
  wh = 3.6;
  xO = xU+wh;
  yO = yU+wh;
  xUStart = -1.8; 
  yUStart = -1.8; 
  xOStart = 1.8;
  yOStart = 1.8;
  whStart = wh;
  zoomFaktor=1;
  Periode = 37.0;
  m=0;
  anzahlPunkteJM = 1000000;
  maxiterations = 300;
  anzahlOrbitPunkte = 10000;
  anzahlStartgebiete = 1;
  trajektZeichnen = false;
  gJMZeichnen = false;
  mMZeichnen = true;
  FPzeichnen = false;
  mMSchreiben = true;
  jMZeichnen = false;
  jMIIMZeichnen = false;
  julia = false;
  cWerteEintragen= false;
  orbit = false;
  vergroessern = false;
  inJulia= false;
  
  rotC=gruenC=false;
 
  C = new double[2];
  C[0] = x0;
  C[1] = y0;
  
  zAlt = new double[2];
  zAlt[0] = 0;
  zAlt[1] = 0;
  
  zNeu = new double[2];
  zNeu[0] = 0;
  zNeu[1] = 0;
  
  zW = new double[2];//Zwischenspeicher für die Wurzel
  zW[0] = 0;
  zW[1] = 0;
 
  koordinaten = new double[2];
  
   Treffer = new int[width][height];
    for (int j =0; j < height; j++) {  
      for (int i = 0; i < width; i++) {
         Treffer[i][j]=0;
      }
    }
   font = createFont("Arial",24);
   rectMode(CENTER);
   textSize(24);  
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
   String s = "jifacpVOJN";
   anzahlT = s.length();
   tasteAktiv = new boolean[anzahlT];
   tBeschriftung = new char[anzahlT];
   for(int i= 0; i<anzahlT; i++) tBeschriftung[i] = s.charAt(i);
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
}
//////////////////////////////////////////////////////////////////////
void draw() {
  
  if(gJMZeichnen){
      loadPixels();
      xO = xU+wh;
      yO = yU+wh;
      dx = (xO - xU)/width;
      dy = (yO - yU)/height;
          
      double y = yU;
      for (int j =height-1; j >= 0; j--) {  
        double x = xU;
        for (int i = 0; i < width; i++) {
           z0 = new double[2];
           z0[0] =x; z0[1] =y;
           int n = juliaIteration(z0,maxiterations);          
           pixels[i+j*width] = colorize(n);        
           x += dx; 
        }
        y += dy; 
      } 
        updatePixels();
       gJMZeichnen = false;
  }
  
  if(jMZeichnen == true && zaehlen < anzahlStartgebiete){//Julia-Menge zeichnen
     
     println("Julia-Menge zeichnen "+zaehlen,anzahlStartgebiete);
    
     fixPunkteBestimmen();// println("Fixpunkte "+z0[0],z0[1],z1[0],z1[1]);//Kontrolle
     juliaIterationR(z0,z1,anzahlPunkteJM); //println(anzahlPunkteJM);
   
     zaehlen++;
     if(zaehlen == anzahlStartgebiete) {
       println("fertig!");
       jMZeichnen = false;
     }
  }
  
   if(jMIIMZeichnen  == true && zaehlen < anzahlStartgebiete){//Julia-Menge mit MIIM zeichnen
     
     println("Julia-Menge mittels MIIM zeichnen "+zaehlen);
    
     fixPunkteBestimmen(); println("Fixpunkte "+z0[0],z0[1],z1[0],z1[1]);//Kontrolle
     juliaIterationRMIIM(z0,z1,anzahlPunkteJM);  
   ;
     zaehlen++;
     if(zaehlen == anzahlStartgebiete) {
       println("fertig!");
       jMIIMZeichnen  = false;
     }
  }
  
  if(mMZeichnen){
      loadPixels();
      xO = xU+wh;
      yO = yU+wh;
      dx = (xO - xU)/width;
      dy = (yO - yU)/height;
          
      double y = yU;
      for (int j =height-1; j >= 0; j--) {  
        double x = xU;
        for (int i = 0; i < width; i++) {
           C = new double[2];
           C[0] =x; C[1] =y;
           int n = mandelbrotIteration(C,maxiterations);          
           pixels[i+j*width] = colorize(n);        
           x += dx; 
        }
        y += dy; 
      }   
       updatePixels();
       mMZeichnen = false;
  }

  if(FPzeichnen){    
      punktGroesse = 6;
      fixPunkteBestimmen();
      punkteEintragen(z0,z1,color(255,0,255),color(0,0,255),punktGroesse);
  }
  if(cWerteEintragen && !julia){
    zA = new double[2]; zB = new double[2];
    
    if(gruenC){
        color f1 = color(0,255,0);
        color f2 = f1;
        zA[0] = -0.7356528043746948; zA[1] = 0.13968722522258759;
        zB[0] = -0.39054; zB[1] = -0.58679;
        punkteEintragen(zA,zB,f1,f2,8);
        zA[0] = -0.481762; zA[1] = -0.531657;
        zB[0] = 0.25; zB[1] = -0.5642857551574707;
        punkteEintragen(zA,zB,f1,f2,8);
        zA[0] =0.32; zA[1] = 0.043;
        zB[0] =-0.7464286088943481; zB[1] = 0.0035715103149414062;
        punkteEintragen(zA,zB,f1,f2,8);
        zA[0] = -1.48;  zA[1] = 0;
        zB[0] = -0.75; zB[1] = 0;
        punkteEintragen(zA,zB,f1,f2,8);
        zA[0] = 0;  zA[1] = 0;
        zB[0] = 0.2696255147457123 ;  zB[1] = 0.005362700670957565;
        punkteEintragen(zA,zB,f1,f2,8);
        zA[0] = 0.06834238767623901;    zA[1] = 0.6154803037643433;
        zB[0] = -0.10933917760848999 ;  zB[1] = 0.894686222076416;
        punkteEintragen(zA,zB,f1,f2,punktGroesse);
    }
    if(rotC){
       color f3 = color(255,0,0);
       color f4 = f3;
       double k = Periode;
       double delta = 2*Math.PI/k;
       alpha = delta;
       while(alpha<2*Math.PI){
         berechneK(alpha); 
         punkteEintragen(koordinaten,koordinaten,f3,f4,punktGroesse);//doppelt, um keine neue Methode zu schreiben
         alpha = alpha + delta; 
       }
    
    }    
  }
  tastenZeichnen();
 
 
}
////////////////////////////////////////////////////////////////
double[] berechneK(double Alpha){
 
  x = Math.cos(Alpha)/2 - Math.cos(2*Alpha)/4;
  y = Math.sin(Alpha)/2 - Math.sin(2*Alpha)/4;
  koordinaten[0] =x;
  koordinaten[1] =y;
  
  return koordinaten;
}
//////////////////////////////////////////////////////////////////////
int juliaIteration(double[] Z, int M) {
  int maxIt = M;
  int n = 0;
  mMSchreiben=false;
  zAlt[0] = Z[0];
  zAlt[1] = Z[1]; 
  if(trajektZeichnen){ 
      if(farbig) {
         colorMode(HSB,255,255,255);
         farbe = color(random(0,255),255,255);
         stroke(farbe);
         colorMode(RGB, 255,255,255);
       }else{
          stroke(0,255,0);
          colorMode(RGB, 255,255,255);
        }
      strokeWeight(6);
      a = (float)zAlt[0];
      b = (float)zAlt[1];
      a = map(a,(float)xU,(float)xO,0,width);
      b = map(b,(float)yU,(float)yO,height,0); 
      point(a,b); 
     
  }
    while (n < maxIt) {
      zNeu = quadratC(zAlt);
      zNeu[0] = zNeu[0]+C[0];
      zNeu[1] = zNeu[1]+C[1];
      laenge = Math.sqrt(zNeu[0]*zNeu[0]+zNeu[1]*zNeu[1]);
      
      if (laenge > massFuerUnendlich) {
        break;  // Bail
      }
      if(trajektZeichnen){    
        a = (float)zNeu[0];
        b = (float)zNeu[1];
       
        a = map(a,(float)xU,(float)xO,0,width);
        b = map(b,(float)yU,(float)yO,height,0);
        if(farbig) stroke(farbe);
          else stroke(255,0,0);
        strokeWeight(punktGroesse);
        point(a,b);
      }
      zAlt[0] = zNeu[0];
      zAlt[1] = zNeu[1];
      n++;
    }
  
  return n;
 }
 ///////////////////////////////////////////////////////////////////////
 void juliaIterationR(double[] Z1, double[] Z2, int M) {
 println("JIR "+xU,xO,yU,yO);
  int maxIt = M;
  int n = 1;
  a =(float) Z1[0];
  b =(float) Z1[1];
  zAlt[0] =a; 
  zAlt[1] =b; 
  colorMode(RGB,256,256,256);
  strokeWeight(10);
  stroke(255,0,255);
  //Fixpunkt (abstoßend) auf Julia-Menge
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  point(aP,bP); 
  //Fixpunkt (anziehend) in Gefangenen-Menge
  stroke(0,0,255);
  a = (float)Z2[0];
  b = (float)Z2[1];
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  point(aP,bP); 
  colorMode(HSB,256,256,256);
  strokeWeight(3);
  stroke(40,255,255);
 
  while (n < maxIt) {
    zNeu[0] = zAlt[0]-C[0];
    zNeu[1] = zAlt[1]-C[1];
    zW = wurzelC(zNeu); 
    zNeu[0] = zW[0];
    zNeu[1] = zW[1];
   
    if(random(0,1)<0.5){
      zNeu[0] = -zNeu[0];  
      zNeu[1] = -zNeu[1]; 
    }     
    a =(float) zNeu[0];
    b =(float) zNeu[1];
    aP = map((float)a,(float)xU,(float)xO,0,width);
    bP = map((float)b,(float)yU,(float)yO,height,0);
    if(n==1)println("hier "+n,aP,bP);
    point(aP,bP);  
         
    zAlt = zNeu;
    n++;
  }
 }
 //////////////////////////////////////////////////////////////////////
 void juliaIterationRMIIM(double[] Z1, double[] Z2, int M) {
   println("JIRMIIM "+xU,xO,yU,yO);
  int maxIt = M;
  int n = 1;
  a =(float) Z1[0];
  b =(float) Z1[1];
  zAlt[0] =a; 
  zAlt[1] =b; 
  colorMode(RGB,256,256,256);
  strokeWeight(10);
  stroke(255,0,255);
  //Fixpunkt (abstoßend) auf Julia-Menge
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  point(aP,bP); 
  //Fixpunkt (anziehend) in Gefangenen-Menge
  stroke(0,0,255);
  a = (float)Z2[0];
  b = (float)Z2[1];
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  point(aP,bP); 
  colorMode(HSB,256,256,256);
  strokeWeight(3);
  stroke(40,255,255);//gelb
  
  while (n < maxIt) {
    zNeu[0] = zAlt[0]-C[0];
    zNeu[1] = zAlt[1]-C[1];
    zW = wurzelC(zNeu); 
    zNeu[0] = zW[0];
    zNeu[1] = zW[1];
   
    if(random(0,1)<0.5){
      zNeu[0] = -zNeu[0];  
      zNeu[1] = -zNeu[1]; 
    }     
    a =(float) zNeu[0];
    b =(float) zNeu[1];
    aP =map((float)a,(float)xU,(float)xO,0,width);
    bP =map((float)b,(float)yU,(float)yO,height,0);
    aPI =round( map((float)a,(float)xUStart,(float)xOStart,0,width));
    bPI =round( map((float)b,(float)yUStart,(float)yOStart,height,0));
    
  if(n==1)println("1_hier "+n,a,b,aPI,bPI);
     if (Treffer[aPI][bPI]< 1){  //bisher kein Treffer 
      
        Treffer[aPI][bPI]++; //anzahlPixel++; //if(anzahlPixel > 10000)println(anzahlPixel);
        point(aP,bP);     
            
     }else{     
   
     float xH = random(-1.5,1.5);
     float yH = random(-1.5,1.5);            
     zNeu = new double[2];
     zNeu[0] = xH;
     zNeu[1] = yH;
     zNeu = juliaStartP(zNeu,vorlauf);
    }   
         
    zAlt[0] = zNeu[0];
    zAlt[1] = zNeu[1];
    n++;
  }
 }
 //////////////////////////////////////////////////////////////////////
int mandelbrotIteration(double[] c, int M) {
  int maxIt = M;
  int n = 0;
 
  zAlt[0] = 0;
  zAlt[1] = 0; 
  C[0] = c[0];
  C[1] = c[1];
  
  if(trajektZeichnen){ 
      if(farbig) {
         colorMode(HSB,255,255,255);
         farbe = color(random(0,255),255,255);
         stroke(farbe);
         colorMode(RGB, 255,255,255);
       }else{
          stroke(0,255,0);
          colorMode(RGB, 255,255,255);
        }
      strokeWeight(6);
      a = (float)zAlt[0];
      b = (float)zAlt[1];
      a = map(a,(float)xU,(float)xO,0,width);
      b = map(b,(float)yU,(float)yO,height,0); 
      point(a,b); 
     
  }
 
  while (n < maxIt) {
    zNeu = quadratC(zAlt);   
    zNeu[0] = zNeu[0]+C[0];
    zNeu[1] = zNeu[1]+C[1];
    laenge = betragC(zNeu);
    
    if (laenge > massFuerUnendlich) {
      break;  // Bail
    }
    if(trajektZeichnen){    
        a = (float)zNeu[0];
        b = (float)zNeu[1];
       
        a = map(a,(float)xU,(float)xO,0,width);
        b = map(b,(float)yU,(float)yO,height,0);
        if(farbig) stroke(farbe);
          else stroke(255,0,0);
        strokeWeight(punktGroesse);
        point(a,b);
    }
   
    zAlt[0] = zNeu[0];
    zAlt[1] = zNeu[1];
    n++;
  }
  return n;
 }

//////////////////////////////////////////////////////////////////////////
void fixPunkteBestimmen(){
 
  z0= new double[2];
  z1= new double[2];
  
  z0[0] =1-4*C[0];
  z0[1] = -4*C[1];
 
  z0 = wurzelC(z0);
 
  z1[0]=z0[0];
  z1[1]=z0[1];
  
  z0[0] =0.5 -0.5*z0[0];
  z0[1] = -0.5*z0[1]; 
  l0 = betragC(z0);
  
  z1[0] =0.5+0.5*z1[0];
  z1[1] = 0.5*z1[1]; 
  l1 = betragC(z1);
  
   if(l0 < l1){ //erster Wert soll auf Julia-Menge liegen
    z  = z1; 
    z1 = z0;
    z0 = z;
   } 
}
///////////////////////////////////////////////////////////////
void punkteEintragen(double[] Z1, double[] Z2, color farbe1, color farbe2, int punktGroesse){
   strokeWeight(punktGroesse);
   
  //Fixpunkt (abstoßend) auf Julia-Menge oder spezieller c-Wert
  stroke(farbe1);
  aP = map((float)Z1[0],(float)xU,(float)xO,0,width);
  bP = map((float)Z1[1],(float)yU,(float)yO,height,0); 
  point(aP,bP); 
 
  //Fixpunkt (anziehend) in Gefangenen-Menge  oder spezieller c-Wert
  stroke(farbe2);
  aP = map((float)Z2[0],(float)xU,(float)xO,0,width);
  bP = map((float)Z2[1],(float)yU,(float)yO,height,0); 
   point(aP,bP);
}
/////////////////////////////////////////////////////////
//Einige Rechnungen auf der Menge der komplexen Zahlen, realisiert durch double[2]
double betragC(double Z[]){
   r = Math.sqrt(Z[0]*Z[0]+Z[1]*Z[1]);
   return r;
}
///////////////////////////////////////////////////////////////
double[] wurzelC(double[] z){
         r = betragC(z);
  double x =  z[0]/r;
  double y =  z[1]/r;
  double w1 = Math.acos(x);
  double w2 = Math.asin(y);
  
  if(x<0 && y<0){
        w1 = 2*Math.PI-w1;
        w2 = Math.PI-w2;    
     }
  if(x<0 && y>0){
        w2 = Math.PI-w2;
     }
     
  z[0] = Math.sqrt(r)*Math.cos(w1/2);
  z[1] = Math.sqrt(r)*Math.sin(w2/2);
  
  return z;  
}
//////////////////////////////////////////////////////////////////
double[] quadratC(double[] z){
     a = (float)z[0];
     b = (float)z[1];
    z[0] = a*a-b*b;
    z[1] = 2*a*b;
    return z;
}
///////////////////////////////////////////////////////////////////////
color colorize(int n) {
  if (n == maxiterations){
    if(gJMZeichnen) farbe = color(0,0,0);
      else farbe = color(0,0,100);
     return  farbe;
  }else{   
    farbe = color(150);    
    return farbe; 
  }
}
///////////////////////////////////////////////////////////////////////////////
void mousePressed() {
 if(mouseY < height-tastenH){ //oberhalb der Tastatur 
 
       if(vergroessern){//Vergrößern
          inJulia = false;
          orbit = false;
          xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
          xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
          xU = xUNeu; xO = xONeu; 
          yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
          yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; println(mouseX,mouseY);
          yU =yUNeu; yO = yONeu; 
          wh = wh/5;
          zoomFaktor =zoomFaktor*5;
          println("Zoomfaktor: "+zoomFaktor);
          if(!julia)mMZeichnen = true;
          if(julia){ gJMZeichnen = true; mMSchreiben = false;}
               
       }
       if (inJulia && !julia){//zugehörige gefüllte Julia-Menge zeichnen
          vergroessern = false;
          orbit = false;
          double x0 = map(mouseX,0,width,(float)xU,(float)xO); 
          double y0 = map(mouseY,0,height, (float)yO,(float)yU);
           println("C "+x0,y0);
          //cWerteEintragen = false;
          C[0] = x0;
          C[1] = y0;
           println("Julia-Menge für das gewählte C = "+C[0],C[1]+"i  zeichnen");
          background(255);
          maxiterations = 300;
          xU = xUStart; xO = xOStart; 
          yU = yUStart; yO = yOStart; 
          wh= xO-xU;
          zoomFaktor=1;
          gJMZeichnen = true;
          julia = true;
          mMSchreiben = false;     
          
       }
       if(orbit){
         m=0;
         vergroessern = false;
         inJulia = false;
         farbig = true;//bei jedem Klick neue Farbe
         orbitZeichnenAb = 1;
         punktGroesse =3;
         trajektZeichnen = true;
         float xH = map(mouseX,0,width,(float)xU,(float)xO); 
         float yH = map(mouseY,0,height, (float)yO,(float)yU);
         z0 = new double[2];
         z0[0] = xH; z0[1] =yH;
         if(julia){
             m = juliaIteration(z0,5000);
         }
         if(!julia){
             m = mandelbrotIteration(z0,5000);
         }
         trajektZeichnen = false;
         farbig = false;
       
       }
 
 }else{
        int ort = int(mouseX/(tastenH));println(ort);
       if(tastenWechsel){
          for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
          tastenWechsel = false;
       }
      switch(ort){
        
      case 0://'j'   
        tasteAktiv[0]=true;
        zaehlen =0;
       //gJMZeichnen = true;
       jMZeichnen = true;
       julia = true;
      break;
      
      case 1: //'i'   
        tasteAktiv[1]=true;
        println("Weitere Punkte auf Julia-Menge mit MIIM zeichnen");
        zaehlen =0;
        punktGroesse = 5;
        Treffer = new int[width][height];
        for (int j =0; j < height; j++) {  
          for (int i = 0; i < width; i++) {
             Treffer[i][j]=0;
          }
        }
       //gJMZeichnen = true;
       jMIIMZeichnen  = true;
       julia = true;
      break;
      
      case 2://'f'
      if(julia){
        tasteAktiv[2]=true;
        punktGroesse = 10;
        FPzeichnen=true;
        redraw();
      }
      break;
      
     case 3://'a'
       tasteAktiv[3]=true;
       FPzeichnen=false;
       colorMode(RGB,255,255,255);
       xU = xUStart; xO = xOStart; 
       yU = yUStart; yO = yOStart; 
       wh= xO-xU;
       zoomFaktor=1;
       maxiterations = 300;
       println("Startwerte wieder herstellen");
       if(!julia) mMZeichnen = true;
         else gJMZeichnen = true; 
     break;
      
     case 4://'c'
         tasteAktiv[4]=true;
         gruenC = true;//gelben C-Werte zeichnen
         punktGroesse = 8;
         cWerteEintragen=true;
         redraw();
      break;
      
     case 5://'p'
        tasteAktiv[5]=true;
        rotC = true;//roten C-Werte zeichnen (indiff FP)
        punktGroesse = 5;
        cWerteEintragen=true;
        redraw();
      break;
      
    case 6://'V'
        tasteAktiv[6]=true;
        vergroessern=!vergroessern;
        orbit = false;
        inJulia = false;
        redraw();
      break;
      
    case 7://'O'
        tasteAktiv[7]=true;
        orbit=!orbit;
        inJulia = false;
        vergroessern=false;
        redraw();
      break;
      
    case 8://'J'
        if(!julia){
        tasteAktiv[8]=true;
        inJulia=!inJulia;
        //jMZeichnen = true;
        vergroessern = false;
        orbit = false;
        redraw();  println(inJulia);
        }
      break;
      
   case 9://'N'
       tasteAktiv[9]=true;
       setup();
       FPzeichnen=false;
       cWerteEintragen= false;
       colorMode(RGB,255,255,255);
       xU = xUStart; xO = xOStart; 
       yU = yUStart; yO = yOStart; 
       wh= xO-xU;
       zoomFaktor=1;
       maxiterations = 300;
       mMZeichnen = true;
       mMSchreiben = true;
       gJMZeichnen = false; 
       cWerteEintragen=false;
       julia = false;
       redraw();
     break;
      
   default:
        
        println("Keine Aktion");
        break;
     }
  }  
}
///////////////////////////////////////////////////////////////////////
void tastenZeichnen(){
  colorMode(RGB,255,255,255);
  stroke(0,0,100);
  tastenWechsel=true;
  textSize(28);
  fill(0,0,100);
  rect(width/2,height-tastenH/2,width,tastenH);
  for(int i=0; i<anzahlT; i++){
      if(tasteAktiv[i])fill(color(255,255,0));
      else fill(color(255));     
      rect(tastenH/2 + i*tastenH,height-tastenH/2,40,40);
      fill(0);
      text(tBeschriftung[i],tastenH/2-8 + i*tastenH,height-tastenH/2+8);     
  }   
  
   fill(255);
  if(mMSchreiben) {   
    text("Mandelbrot Menge",520,830);    
  }
  if(!mMSchreiben) { 
    text("Julia Menge",520,830);
  } 
}
//////////////////////////////////////////////////////////////////////
double[] juliaStartP(double[] Z, int k){
  z= new double[2];
  z[0] = Z[0];z[1] = Z[1];
  for(int i =0; i<k; i++){     
     z[0] = z[0]-C[0];
     z[1] = z[1]-C[1];
     z= wurzelC(z);
    if(random(0,1)<0.5) {
       z[0] = -z[0];
       z[1] = -z[1];
     }
  }
  return z; 
}
 //////////////////////////////////////////////////////////////////////
